<div align="center">
<img src="https://user-images.githubusercontent.com/50536495/170400421-0c3a1711-4484-42b1-995b-ee0095c3c7cb.png" width = "210" height = "210" alt="Get it on F-Droid"/>
  <h1>PixaPencil</h1>
  <p><b>The #1, open source pixel art editor for Android</b><br>

[![Discord](https://img.shields.io/badge/Discord-PixaPencil-blue.svg)](https://discord.com/invite/Ytm7WBMNz9)
[![Matrix](https://img.shields.io/badge/Matrix-PixaPencil-green.svg)](https://matrix.to/#/#pixapencil:matrix.org)
[![License](https://img.shields.io/badge/License-MIT-red.svg)](https://choosealicense.com/licenses/mit/)

[<img src="https://github.com/machiav3lli/oandbackupx/blob/034b226cea5c1b30eb4f6a6f313e4dadcbb0ece4/badge_github.png" alt="Get it on GitHub" height="80">](https://github.com/therealbluepandabear/PixaPencil/releases/latest)
[<img src="https://fdroid.gitlab.io/artwork/badge/get-it-on.png" alt="Get it on F-Droid" height="80">](https://f-droid.org/en/packages/com.therealbluepandabear.pixapencil/)
</div>

## 🗏 About

PixaPencil is the number one open source pixel art editor for Android.

Why you should try out PixaPencil:

- Contains over 33+ useful features (see 'Features' section below)
- 100% free of evil Google Play (tracking) services
- 100% free of evil (tracking) advertisements
- 100% commitment to open source

**Warning: if you have a phone with a _very_ small screen size (e.g. 400x800 Galaxy Core Prime) this app will not work well. Keep that in mind. I am working on making this app more compatible with smaller screen sizes, but for now it's on hold.**

PixaPencil is available in either English (US), English (UK/NZ/AU, etc), or Hebrew.

PixaPencil only runs on Android 8.0 or higher.

## 🖼️ Showcase

![image](https://user-images.githubusercontent.com/50536495/164863846-a2616e20-e7d1-4cf8-a659-ce0ab43586a0.png)
![image](https://user-images.githubusercontent.com/50536495/164864089-84f657b4-c08a-4dd2-bde5-560a4c78e3f1.png)

![image](https://user-images.githubusercontent.com/50536495/164866012-fa1ce32f-aa80-41cc-887c-94ddf09d33f3.png)
![image](https://user-images.githubusercontent.com/50536495/164866021-b992b5e6-b1ff-49f8-a77b-91feab887b23.png)

![image](https://user-images.githubusercontent.com/50536495/164867306-ed7262f8-e33b-45d3-8e04-8ff122d845ba.png)
![image](https://user-images.githubusercontent.com/50536495/164867362-bda11589-5bae-4872-b927-397875b0d35a.png)

![image](https://user-images.githubusercontent.com/50536495/152713363-a873fdd3-ecc6-4939-a495-28c4a35abbdb.png)
![image](https://user-images.githubusercontent.com/50536495/152713464-9049586a-2332-4625-b31d-99d822625879.png)

**If you want to showcase an image of your own please send me an email at therealbluepandabear@gmail.com.**

## 📜 License

To disclaim, this repository is licensed under the MIT license.

For more info go to: https://choosealicense.com/licenses/mit/.

_Do not use the name '**PixaPencil**' in your app/other product._

## 📝 Features (as of June 13, 2022)
- Pencil tool
- Move tool
- Fill tool 
- Line tool
- Rectangle tool
- Outlined rectangle tool
- Square tool
- Outlined square tool
- Ellipse Tool
- Outlined Ellipse Tool
- Circle Tool
- Outlined Circle Tool
- Spray tool
- Polygon tool
- Dither tool **with custom dither brushes**
- Shading tool
- Picker tool
- Find and replace by color tool
- Erase tool
- Pixel grid
- Pixel perfect mode
- 4 symmetry options (horizontal, vertical, quad, octal) 
- Undo
- Redo
- Zoom in
- Zoom out
- Canvas filters (color filter, lighten, darken, invert, grayscale)
- Color palette support
- Brushes
- Ability to select custom colors using a color picker, RGB sliders, or HEX code
- Ability to unfavorite/favorite projects
- Ability to export projects to PNG/JPG/WEBP/TIFF/BMP
- Ability to rotate the canvas 90 degrees clockwise and anti-clockwise, as well as 180 degrees
- Ability to save projects in background

Go to https://github.com/therealbluepandabear/PixaPencil/projects to have a look at features we want to add to **PixaPencil**.

# 📓 Translations
If you spot issues with the translation send me an email at therealbluepandabear@gmail.com or open an issue request.

## 📚 Other libraries used
- duanhong169 (https://github.com/duanhong169) - ColorPicker (https://github.com/duanhong169/ColorPicker)
- yshrsmz (https://github.com/yshrsmz) - KeyboardVisibilityEvent (https://github.com/yshrsmz/KeyboardVisibilityEvent) 
- Beyka (https://github.com/Beyka) - Android-TiffBitmapFactory (https://github.com/Beyka/Android-TiffBitmapFactory)

## Mirror Repo (in case of censorship)

https://bitbucket.org/thebluepandabear/pixapencil/src/master/
